# from https://deeplearning.neuromatch.io/projects/ComputerVision/spectrogram_analysis.html
# architecture as in https://github.com/chrisdonahue/ddc
# @inproceedings{donahue2017dance,
#   title={Dance Dance Convolution},
#   author={Donahue, Chris and Lipton, Zachary C and McAuley, Julian},
#   booktitle={Proceedings of the 34th International Conference on Machine Learning},
#   year={2017},
# }
# Make a CNN
import torch
import torch.nn as nn
import torch.nn.functional as F


class music_net(nn.Module):
    def __init__(self):
        """Intitalize neural net layers"""
        super(music_net, self).__init__()
        # conv1d, original paper? freq as channel
        # better: no padding, use image better
        self.conv1 = nn.Conv2d(in_channels=3, out_channels=10, kernel_size=(7, 3), stride=(1, 3), padding=(3, 0))
        self.conv2 = nn.Conv2d(in_channels=10, out_channels=20, kernel_size=(3, 3), stride=(1, 3), padding=(1, 0))
        #self.fc1 = nn.Linear(in_features=7280, out_features=256) # in_features not 20, always 7280?
        #self.fc2 = nn.Linear(in_features=256, out_features=128)
        self.m = nn.MaxPool2d(kernel_size=(1, 3), stride=(1, 3))

        # self.batchnorm1 = nn.BatchNorm2d(num_features=8)
        # self.batchnorm2 = nn.BatchNorm2d(num_features=16)

        self.dropout = nn.Dropout(p=0.5, inplace=False)

    def forward(self, x):
        # Conv layer 1.
        x = self.conv1(x)
        # x = self.batchnorm1(x)
        x = F.relu(x)
        # only in frequency domain?
        # x = F.max_pool1d(x, kernel_size=3, stride=3)
        x = self.m(x)

        # Conv layer 2.
        x = self.conv2(x)
        # x = self.batchnorm2(x)
        x = F.relu(x)
        # x = F.max_pool1d(x, kernel_size=3, stride=3)
        print(x.shape)
        x = self.m(x)
        # batch, time, freq, chanel dim check
        x = x.view(-1, x.shape[-3], x.shape[-2]*x.shape[-1])

        # Fully connected layer 1.
        #x = torch.flatten(x, 1)
        #print(x.shape)
        #x = self.fc1(x)
        #print(x.shape)
        # apply 50% dropout following each LSTM and fully connected layer
        #x = self.dropout(x)
        #x = F.relu(x)
        # x = F.softmax(x)

        # Fully connected layer 2.
        #x = torch.flatten(x, 1)
        #x = self.fc2(x)
        #x = self.dropout(x)
        #x = F.relu(x)
        # x = F.softmax(x)

        return x
