# from https://deeplearning.neuromatch.io/projects/ComputerVision/spectrogram_analysis.html
# https://pytorch.org/tutorials/beginner/transformer_tutorial.html
import matplotlib.pyplot as plt

def plot_loss_accuracy(train_loss, train_acc, validation_loss, validation_acc):
    plt.figure(figsize=(10, 5))
    plt.title("Training and Validation Loss")
    plt.plot(validation_loss, label="val_loss")
    plt.plot(train_loss, label="train_loss")
    plt.xlabel("Epochs")
    plt.ylabel("Loss")
    plt.legend()
    plt.savefig("./outputs/specs/loss.png")

    plt.figure(figsize=(10, 5))
    plt.title("Training and Validation Accuracy")
    plt.plot(train_acc, label="train_acc")
    plt.plot(validation_acc, label="val_acc")
    plt.xlabel("Epochs")
    plt.ylabel("Accuracy")
    plt.legend()
    plt.savefig("./outputs/specs/accuracy.png")